{% extends "layouts/presentations/c_cpp_introduction.njk" %}

{% set title = "Programming in C++" %}
{% set subtitle = "Introduction" %}

{% set language = "C++" %}
{% set language_ = "cpp" %}
{% set compiler = "clang++" %}
{% set alt_compiler = "g++" %}

{% block language_intro %}

<section>
  <h2>Advantages of C++</h2>
  <section>
    <h3>Multi-Paradigm</h3>
      <p>Proper implementation of multiple programming paradigms</p>
      <ul>
        <li>Procedural programming</li>
        <li>Object-Oriented programming (OOP)</li>
        <li>Generic programming</li>
        <li>Functional programming</li>
      </ul>
  </section>

  <section>
    <h3>High-Level Programming</h3>
    <p>The standard template library (STL) provides algorithms and containers
      allowing the programmer to focus on the problem.
    </p>
    <ul>
      <li>array, list, map, set, string, vector, ... - see
        <a href="https://en.cppreference.com/w/cpp/container">containers
          library</a></li>
      <li>algorithms are provided in the
        <a href="https://en.cppreference.com/w/cpp/algorithm">algorithms</a>
        and
        <a href="https://en.cppreference.com/w/cpp/numeric">numerics</a>
        libraries
      </li>
    </ul>
    <div class="fragment">
      <p>Third party libraries cover almost everything well (except the
        web).</p>
      <p>Examples include
        <a href="https://www.boost.org/">boost</a>,
        <a href="https://www.libsdl.org/">SDL</a>,
        <a href="https://www.wxwidgets.org/">wxWidgets</a>
        and many more. See this
        <a href="https://en.cppreference.com/w/cpp/links/libs">
          comprehensive list of open source C++ libraries</a>.
      </p>
    </div>
  </section>
  <section>
    <h3></h3>
    <ul>
      <li>Low-level programming close to the hardware is possible (like in C)</li>
      <li>High performance (fast execution speed)</li>
      <li>Exception handling, namespaces, ...</li>
      <li>Large community (<a href="https://www.tiobe.com/tiobe-index/">TIOBE Index</a>,
        <a href="https://www.openhub.net/languages/compare?language_name%5B%5D=c&language_name%5B%5D=cpp&language_name%5B%5D=csharp&language_name%5B%5D=java&language_name%5B%5D=-1&language_name%5B%5D=python&language_name%5B%5D=-1&measure=commits">Open Hub Language Comparison</a>)
        <ul>
          <li>Open source compilers and tools</li>
          <li>Abundance of resources for learning</li>
          <li>Ever-evolving</li>
        </ul>
      </li>
    </ul>
  </section>

</section>

<section>
  <h2>Brief History</h2>
  <dl>
    <dt>1979</dt>
    <dd>Bjarne Stroustrup started development of C++ at Bell Labs</dd>
    <dt>1985</dt>
    <dd>first edition of C++ was released</dd>
    <dt>1989</dt>
    <dd>C++ 2.0</dd>
    <dt>1998</dt>
    <dd>C++98 was released, standardizing the language</dd>
    <dt>2011</dt>
    <dd>C++11 offers numerous new features and enlarges the standard library</dd>
    <dt>thereafter</dt>
    <dd>C++14, C++17 and C++20</dd>
    <dd>C++23 in the making</dd>
  </dl>
</section>

<section>
  <h2>Differences from C</h2>
  <section>
    <p><strong>C++ is not a strict superset of C.</strong></p>
    <p>Code that is valid C is not automatically valid C++.</p>
    <div class="fragment">
    <p>For example, C++ offers many additional features compared to C.
      These include proper object
      orientation, anonymous functions, operator overloading, templates
      and many more.
    </p>
    <p>Therefore, C++ uses many additional keywords that cannot be used as
      identifiers anymore. These include
      <code>auto</code>, <code>class</code>, <code>namespace</code>,
      <code>new</code> ...
    </p>
    </div>
  </section>
  <section>
    <h3>Example</h3>
{% highlight "cpp" %}
{% include "source/cpp/valid_c.c" %}
{% endhighlight %}
    <p>{% download "/data/cpp/valid_c.c" %}</p>
    <p class="fragment">
      Wikipedia has more information on
      <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Compatibility_of_C_and_C%2B%2B">compatibility of C and C++</a>
    </p>
  </section>
</section>

{% endblock %}



{% include 'slides/closing.njk' %}
